org.apache.commons.math3.optimization

## Class BaseMultivariateVectorMultiStartOptimizer<FUNC extends MultivariateVectorFunction>

- java.lang.Object
- - org.apache.commons.math3.optimization.BaseMultivariateVectorMultiStartOptimizer<FUNC>

- Type Parameters:
    `FUNC` - Type of the objective function to be optimized.
  All Implemented Interfaces:
    BaseMultivariateVectorOptimizer<FUNC>, BaseOptimizer<PointVectorValuePair>
  Direct Known Subclasses:
    DifferentiableMultivariateVectorMultiStartOptimizer, MultivariateDifferentiableVectorMultiStartOptimizer

  Deprecated.
  As of 3.1 (to be removed in 4.0).

      @Deprecated
      public class BaseMultivariateVectorMultiStartOptimizer<FUNC extends MultivariateVectorFunction>
      extends Object
      implements BaseMultivariateVectorOptimizer<FUNC>

  Base class for all implementations of a multi-start optimizer. This interface is mainly intended to enforce the internal coherence of Commons-Math. Users of the API are advised to base their code on `DifferentiableMultivariateVectorMultiStartOptimizer`.
  Since:
    3.0
  Version:
    $Id: BaseMultivariateVectorMultiStartOptimizer.java 1422230 2012-12-15 12:11:13Z erans $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private RandomVectorGenerator` | `generator` Deprecated. Random generator for multi-start.
    `private int` | `maxEvaluations` Deprecated. Maximal number of evaluations allowed.
    `private PointVectorValuePair[]` | `optima` Deprecated. Found optima.
    `private BaseMultivariateVectorOptimizer<FUNC>` | `optimizer` Deprecated. Underlying classical optimizer.
    `private int` | `starts` Deprecated. Number of starts to go.
    `private int` | `totalEvaluations` Deprecated. Number of evaluations already performed for all starts.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BaseMultivariateVectorMultiStartOptimizer(BaseMultivariateVectorOptimizer<FUNC> optimizer, int starts, RandomVectorGenerator generator)` Deprecated. Create a multi-start optimizer from a single-start optimizer.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ConvergenceChecker<PointVectorValuePair>` | `getConvergenceChecker()` Deprecated. Get the convergence checker.
    `int` | `getEvaluations()` Deprecated. Get the number of evaluations of the objective function.
    `int` | `getMaxEvaluations()` Deprecated. Get the maximal number of function evaluations.
    `PointVectorValuePair[]` | `getOptima()` Deprecated. Get all the optima found during the last call to `optimize`.
    `PointVectorValuePair` | `optimize(int maxEval, FUNC f, double[] target, double[] weights, double[] startPoint)` Deprecated. Optimize an objective function.
    `private void` | `sortPairs(double[] target, double[] weights)` Deprecated. Sort the optima from best to worst, followed by `null` elements.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### optimizer

          private final BaseMultivariateVectorOptimizer<FUNC extends MultivariateVectorFunction> optimizer

      Deprecated.
      Underlying classical optimizer.

    - #### maxEvaluations

          private int maxEvaluations

      Deprecated.
      Maximal number of evaluations allowed.

    - #### totalEvaluations

          private int totalEvaluations

      Deprecated.
      Number of evaluations already performed for all starts.

    - #### starts

          private int starts

      Deprecated.
      Number of starts to go.

    - #### generator

          private RandomVectorGenerator generator

      Deprecated.
      Random generator for multi-start.

    - #### optima

          private PointVectorValuePair[] optima

      Deprecated.
      Found optima.

  - ### Constructor Detail

    - #### BaseMultivariateVectorMultiStartOptimizer

          protected BaseMultivariateVectorMultiStartOptimizer(BaseMultivariateVectorOptimizer<FUNC> optimizer,
                                                   int starts,
                                                   RandomVectorGenerator generator)

      Deprecated.
      Create a multi-start optimizer from a single-start optimizer.
      Parameters:
        `optimizer` - Single-start optimizer to wrap.
        `starts` - Number of starts to perform. If `starts == 1`, the `optimize` will return the same solution as `optimizer` would.
        `generator` - Random vector generator to use for restarts.
      Throws:
        `NullArgumentException` - if `optimizer` or `generator` is `null`.
        `NotStrictlyPositiveException` - if `starts < 1`.

  - ### Method Detail

    - #### getOptima

          public PointVectorValuePair[] getOptima()

      Deprecated.
      Get all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
      The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e. in ascending order if minimizing and in descending order if maximizing), followed by and null elements corresponding to the runs that did not converge. This means all elements will be null if the `optimize` method did throw a `ConvergenceException`). This also means that if the first element is not `null`, it is the best point found across all starts.
      Returns:
        array containing the optima
      Throws:
        `MathIllegalStateException` - if `optimize` has not been called.

    - #### getMaxEvaluations

          public int getMaxEvaluations()

      Deprecated.
      Get the maximal number of function evaluations.
      Specified by:
        `getMaxEvaluations` in interface `BaseOptimizer<PointVectorValuePair>`
      Returns:
        the maximal number of function evaluations.

    - #### getEvaluations

          public int getEvaluations()

      Deprecated.
      Get the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.
      Specified by:
        `getEvaluations` in interface `BaseOptimizer<PointVectorValuePair>`
      Returns:
        the number of evaluations of the objective function.

    - #### getConvergenceChecker

          public ConvergenceChecker<PointVectorValuePair> getConvergenceChecker()

      Deprecated.
      Get the convergence checker.
      Specified by:
        `getConvergenceChecker` in interface `BaseOptimizer<PointVectorValuePair>`
      Returns:
        the object used to check for convergence.

    - #### optimize

          public PointVectorValuePair optimize(int maxEval,
                                      FUNC f,
                                      double[] target,
                                      double[] weights,
                                      double[] startPoint)

      Deprecated.
      Optimize an objective function. Optimization is considered to be a weighted least-squares minimization. The cost function to be minimized is `∑weighti(objectivei - targeti)2`
      Specified by:
        `optimize` in interface `BaseMultivariateVectorOptimizer<FUNC extends MultivariateVectorFunction>`
      Parameters:
        `maxEval` - Maximum number of function evaluations.
        `f` - Objective function.
        `target` - Target value for the objective functions at optimum.
        `weights` - Weights for the least squares cost computation.
        `startPoint` - Start point for optimization.
      Returns:
        the point/value pair giving the optimal value for objective function.

    - #### sortPairs

          private void sortPairs(double[] target,
                       double[] weights)

      Deprecated.
      Sort the optima from best to worst, followed by `null` elements.
      Parameters:
        `target` - Target value for the objective functions at optimum.
        `weights` - Weights for the least-squares cost computation.

Copyright (c) 2003-2013 Apache Software Foundation